    setClass("opt", 
	representation(writecon = "logical", 
			writespec = "logical", 
			writenormspec = "logical", 
			writefit = "logical", 
			writefitivo = "logical",
			writeclperr = "logical",
			residplot = "logical", 
			plot = "logical",
                        minFactor = "numeric", 
			output = "character",
			nnls = "numeric", 
			divdrel = "logical", 
			noplotest = "logical",
			plotkinspec = "logical",
                        nls = "logical",
                        superimpose = "vector",
			xlab = "character",
			ylab = "character",
                        title = "character",
			makeps = "character",
			linrange = "numeric",
			summaryplotrow = "numeric",
			summaryplotcol = "numeric",
			iter = "numeric",
			stderrclp = "logical",
                       	trilinear = "logical",
                        getStartTri = "logical",
                        triStart = "list",
                        paropt="list", 
			addfilename = "logical",
			addest="vector", 
			kinspecerr = "logical",
			xlimspec = "vector",
			ylimspec = "vector",
			ylimspecplus = "vector",
			specinterpol = "logical",
			specinterpolpoints = "logical",
			specinterpolseg = "numeric",
			specinterpolbspline = "logical",
			samespecline = "logical",
			normspec = "logical",
			writespecinterpol = "logical", 
			nnlscrit = "list",
                        nlsalgorithm = "character"
			), 
        prototype = list(writecon = FALSE, 
			writespec = FALSE,
			writenormspec = FALSE,
			writefit = FALSE,
                        writefitivo = FALSE,
			writeclperr = FALSE, 
                        nls = TRUE,
			noplotest = FALSE,
                        residplot = FALSE, 
			plotkinspec = FALSE,
                        minFactor = 1/1024,
                        plot = TRUE,
                        trilinear = FALSE,
                        getStartTri = TRUE,
                        triStart = list(),
			addfilename = FALSE,
			divdrel = TRUE, 
			output = "ps", 
			nnls = 0,
			superimpose = vector(),
			paropt = list(),
			title = "",
			makeps = "",
			stderrclp = FALSE, 
			summaryplotrow = 4, 
			summaryplotcol = 4,
			linrange = 1,
			iter = 1, 
			addest=vector(), 
			kinspecerr = FALSE,
			ylimspecplus = vector(), 
			xlimspec = vector(),
			ylimspec = vector(),
			specinterpol = FALSE,
			specinterpolpoints = TRUE, 
			specinterpolseg = 50,
			specinterpolbspline = FALSE,
			normspec = FALSE,
			writespecinterpol = FALSE, 
			samespecline = FALSE,
			nnlscrit = list(),
                        nlsalgorithm = "default"
			))

setClass("kinopt", representation("opt",
                                  notraces = "logical",
                                  selectedtraces = "vector",
                                  breakdown = "list",
                                  FLIM = "logical", 
                                  FLIMresidimag = "logical",
                                  noFLIMsummary = "logical",
                                  writerawcon = "logical",
                                  plotcohcolspec = "logical", 
                                  kinspecest = "logical",
                                  writeplaincon = "list"),
         prototype = list( notraces = FALSE,
           selectedtraces = vector(),
           breakdown = list(),
           writerawcon = FALSE,
           plotcohcolspec = TRUE,
           addest = c("kinpar"),
           FLIM = FALSE,	
           FLIMresidimag = TRUE, 
           noFLIMsummary = FALSE,
           paropt =  par(mgp = c(1.5, 1, 0), 
             mai = c(0.5, 0.6, .5, 0.5),mar=c(3,3,4,1)),
           xlab = "time",
           ylab = "wavelength",
           kinspecest = FALSE,
           writeplaincon = list()))

setClass("massopt", representation("kinopt", axis.by = "numeric",
        scale.concen = "logical", nummaxtraces = "numeric"), prototype
        = list(normspec = TRUE, axis.by = 30, scale.concen = TRUE,
        nummaxtraces = 0) )


setClass("specopt", representation("opt", nospectra = "logical",
			   selectedspectra = "vector"), prototype =
			   list( nospectra = FALSE, selectedspectra =
			   vector(), xlab = "wavelength", ylab =
			   "time"))

